local config = require( 'saotrace.config' ).raygen

describe( "not exist", function()

   local ok, msg = pcall( function ()
			     config.not_exist = 3
			  end
		      )

   it( 'set', function ()
       assert.is_false( ok )
   end)

   it( 'set error message', function ()
       assert.matches( 'unknown element', msg )
   end)


   local ok, msg = pcall( function ()
			     return config.not_exist
			  end
		       )

   it ( 'get', function ()
       assert.is_false( ok )
   end)

   it ( 'get error message', function ()
       assert.matches( 'unknown element', msg )
   end)

end)

describe( "jitter intersect", function ()

   -- check default, it should evaluate to true
   it ( 'default', function()
       assert.is_true( config.jitter.tintersect )
    end)

   -- change it
   it( 'changed', function()
      assert.is_true( pcall( function ()
			  config.jitter.tintersect = false
		       end
		    )
	     )

      -- and see if it's tracked
      assert.is_false( config.jitter.tintersect )

   end)

end)
