// -*-C++-*-
#ifndef JITTER_BASE_H
#define JITTER_BASE_H

#include <string>
#include <cfloat>

#include <Eigen/Core>
#include <Eigen/Geometry>

#include "rTime.h"
#include "Jitter/jutils.h"

namespace Jitter {

    class Base {

    public:

	std::string name;

	// time interval over which jitter is valid.
	raygen::TimeInterval tvalid;

	// apply this matrix to the input coordinates to get raytrace coordinates
	Eigen::Quaterniond coord_xfrm;

	virtual void jitter( double time, Eigen::Quaterniond &q ) = 0;

        Base() :
	    coord_xfrm(Eigen::Quaterniond::Identity())
	{}

        Base( std::string& name ) :
	    name(name),
	    coord_xfrm(Eigen::Quaterniond::Identity())
	{}

        Base( const char* name )  :
	    name(name),
	    coord_xfrm(Eigen::Quaterniond::Identity())
	{}

	virtual ~Base() {};

    };

}


#endif // ! JITTER_BASE_H
