// -*-C++-*-
#ifndef LUASTATE_H
#define LUASTATE_H

#include <lua.hpp>

class LuaState {

public:

    LuaState();
    ~LuaState();

    operator lua_State*() { return L; }

    void get_module_attr( const char* module, const char* attr );
    void set_module_attr( const char* module, const char* attr );

    void register_module( const char* module, luaL_Reg* l );
    void register_module( const char* module, luaL_Reg* fptr[] );
    void register_module( const char* module  );

    void require_module( const char* module, bool push_module = false );

    void call_module_func( const char* module, const char* func,
				     int nargs, int nresults);

private:
    lua_State* L;
    int package_loaded;

    void get_package_loaded();

};


#endif // LUASTATE_H
