#ifndef DIR_GEN_H
#define DIR_GEN_H

typedef struct DirectionGenerator DirectionGenerator;

#include "source.h"

typedef struct
{
  size_t	iter_lim;		/* maximum number of iterations to
  					   satisfy modifier events */
  size_t	iter_warn;		/* number of iterations
					   between modifier warnings */
  void *	data;			/* flux generator specific data */
} DirectionGeneratorData;


typedef   int(*DirGenInit)( DirectionGeneratorData *);
typedef   int(*DirGenCheck)( void *, DVector3 *);
typedef   void(*DirGenCleanup)( void *);

typedef struct
{
    const char *  name;		/* the name of the flux generator */
    DirGenInit    init;
    DirGenCheck	  check;
    DirGenCleanup cleanup;
} DirectionGeneratorSpec;

struct  DirectionGenerator
{
  struct Source	*	source;		/* the parent source of the
					   generator */
  DirectionGeneratorSpec spec;
  DirectionGeneratorData data;
  char *	name;
};


void new_dir_gen(DirectionGeneratorSpec *spec, char *name, void *data);
int delete_dir_gen(void *data);

#endif /* !  DIR_GEN_H */
