/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2010 Smithsonian Astrophysical Observatory
 *
 * This file is part of raygen
 *
 * raygen is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * -->8-->8-->8-->8-- */

#ifndef EA_H
#define EA_H

#include <lua.hpp>

#include "types.h"

typedef void(*EA_Pos)( void *, DVector3 * );
typedef void(*EA_Cleanup)( void * );

typedef struct EntranceAperture
{
    void *	data;
    double	area;
    double	area_min;
    double	area_max;
    unsigned long id;

    EA_Pos 	pos;
    EA_Cleanup	cleanup;
} EntranceAperture;

void
new_entrance_aperture( lua_State *L,
		       const char* errpfx,
		       void *data,
		       unsigned int id,
		       double area,
		       EA_Pos  pos,
		       EA_Cleanup cleanup );

void ea_setup( );
void ea_init( );
void ea_cleanup(void);
void entrance_aperture( Photon *photon, double z );

#endif /* ! EA_H */
