#ifndef JITTER_GEN_H
#define JITTER_GEN_H

#include <string>
#include <vector>
#include <memory>

#include "events.h"

#include "rTime.h"
#include "Jitter/Base.h"

class JitterGenerator  {

 public :
    std::vector< Jitter::Base* > generators;

 JitterGenerator() : jitter(Eigen::Quaterniond::Identity()){};
    ~JitterGenerator() {

	std::vector< Jitter::Base* >::iterator gen;

	for( gen = generators.begin(); gen < generators.end() ; gen++ )
	    delete *gen;
    }

    void apply( double time, DVector3& direction );

    bool     empty() { return generators.empty(); }
    void init( Eigen::Quaterniond& roll );
    double tmin() { return tvalid.min; }
    double tmax() { return tvalid.max; }

 private :
    Eigen::Quaterniond jitter;
    Eigen::Quaterniond _roll;

    raygen::TimeInterval tvalid;

};

#endif /* ! JITTER_GEN_H */
