#include "config.h"

#include "common.h"

#include "lua_system.h"

static int
logfile( lua_State *L ) {

    lua_pushstring( L, sys.logfile );
    return 1;
}

static int
nsources( lua_State *L ) {

    lua_pushinteger( L, sll_count(sys.sources ) );
    return 1;
}


static
luaL_Reg system_funcs[] =  {

    { "logfile", logfile },
    { "nsources", nsources },

    /* -- place new luaL_Reg structures above this line  -- */
    NULL
};

void
luaopen_raygen_system( LuaState& L ) {

    L.register_module( "saotrace.raygen.system", system_funcs );

}
