/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of raygen
 *
 * raygen is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * raygen is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <stdlib.h>
#include <stdio.h>

#include <tracefctxx/TraceFct.h>

#include "image.h"

double *
rd_image_data_double( const char *err_pfx, const char *image, size_t npix )
{
  size_t nr;
  FILE *file;

  if ( NULL == ( file = fopen( image, "r" ) ) )
  {
    TraceFct::message( "error opening image file `%s'\n", image );
    return NULL;
  }
  
  double* data = new (nothrow) double[npix];
  if ( NULL == data )
  {
    TraceFct::message( "error allocating image data (%d bytes)\n",
    		 npix * sizeof(double) );
    return NULL;
  }

  if ( npix != (nr = fread( data, sizeof(double), npix, file )) )
  {
    TraceFct::message( "error reading image data (read %d pixels, expected %d)\n",
		nr, npix );
    return NULL;
  }

  return data;
}
