#ifndef TYPES_H
#define TYPES_H

#include <bpipe/datatypes.h>

/*
  the type of module that the source specification script
  is in the midst of building
 */
typedef enum
{
  Mod_SOURCE,	/* source */
  Mod_FGEN,	/* flux generator */
  Mod_FMOD,	/* flux modifier */
  Mod_EGEN,	/* extent generator */
  Mod_DGEN,	/* direction generator */
  Mod_PGEN	/* position generator */
} ModuleType;

/* the limit on the number of photons that are generated */
typedef enum
{
  Limit_COUNTS,
  Limit_DENSITY,
  Limit_TIME
} LimitType;

typedef struct
{
  double energy;
  double time;
  unsigned int id;
  unsigned int eap_id;
  DVector3 position;
  DVector3 direction;
} Photon;


typedef struct Mirror {
  double rho_f;
  double rho_a;
  double z_f;
  double z_a;
  double l;
  double node;
} Mirror;


#endif /* ! TYPES_H */
