local table = require( 'table' )
local os = require( 'os' )

local top_srcdir = os.getenv('top_srcdir') or '.'

local image = table.concat( { top_srcdir, 'tests', 'data', 'ell.fits'}, '/' )

name = 'image'

source.create( name,
	       {
		  extent = extent.image{
		     name = name,
		     file = image,
		     pixsz = { x = 0.1, y = 0.1 },
		     rotate = 65,
		     position = { theta = { 10, 'arcseconds' },
				  phi = { 125, 'degree' }
			       },
		  },
		  spectrum = spectrum.mono{
		     name = name,
		     energy = 1.49 },
	       }
	    )

source.create( name,
	       {
		  extent = extent.image{
		     name = name,
		     file = image,
		     pixsz = { x = {0.1, 'arcseconds'}, y = 0.1 },
		     rotate = 65,
		     position = { theta = { 10, 'arcseconds' },
				  phi = { 125, 'degree' }
			       },
		  },
		  spectrum = spectrum.mono{
		     name = name,
		     energy = 1.49 },
	       }
	    )
