#include <string>
#include <iostream>

#include <lua.hpp>
#include <lauxlib.h>

#include "gtest/gtest.h"
#include "t_utils.h"

#include "LuaState.h"
#include "sysconf.h"

using namespace std;


class StackTest : public testing::Test {

protected:

    LuaState *L;

    virtual void SetUp() {

	L = new LuaState();
    }

    virtual void TearDown() {

	delete L;
    }

};



TEST_F( StackTest, config_jitter ) {

    int err = luaL_dostring( *L, "require( 'saotrace.config' )" );
    ASSERT_EQ( 0, err ) << lua_tostring(*L, -1 );

    SysConf conf( *L, "saotrace.config", "raygen" );

    EXPECT_TRUE( conf.get_bool("jitter.tintersect") );

}
