#include "t_utils.h"

#include <iostream>

void stackDump( lua_State* L ) {

    int i;

    int top = lua_gettop(L);

    for ( i = top ; i > 0 ; i-- ) {
	int t = lua_type(L, i );
	std::cerr << '[' << i << "]: " << lua_typename(L, t) << ": ";
	switch(t) {

	case LUA_TSTRING:
	    std::cerr << lua_tostring(L, i);
	    break;

	case LUA_TBOOLEAN:
	    std::cerr << (lua_toboolean(L, i) ? "true" : "false");
	    break;

	case LUA_TNUMBER:
	    std::cerr << lua_tonumber(L, i);
	    break;

	default:
	    //	    std::cerr << lua_tostring(L, i);
	    break;
	}

	std::cerr << std::endl;
    }
}
