#include <iostream>
#include "gtest/gtest.h"

#include "units.h"

using namespace std;
using namespace raygen;

TEST( UNITS, parse_string ) {

    ut_unit* unit = Units::parse( string("mm") );
    ASSERT_TRUE( NULL != unit );

    EXPECT_EQ( 0, ut_compare( unit, Units::sys().mm() ) );

}

TEST( UNITS, parse_char ) {

    ut_unit* unit = Units::parse( "mm" );
    ASSERT_TRUE( NULL != unit );
    EXPECT_EQ( 0, ut_compare( unit, Units::sys().mm() ) );

}

TEST( UNITS, convert_unit ) {

    ut_unit* unit = Units::parse( "meter" );
    ASSERT_TRUE( NULL != unit );

    double value = 1;
    ASSERT_TRUE( Units::convert( unit, Units::sys().mm(), value ) );
    EXPECT_EQ( 1000 , value  );

}

TEST( UNITS, convert_string ) {

    double value = 1;
    ASSERT_TRUE( Units::convert( string("m"), Units::sys().mm(), value ) );
    EXPECT_EQ( 1000 , value  );

}
