#include <string>
#include <iostream>

#include <lua.hpp>
#include <lauxlib.h>


#include "gtest/gtest.h"

#include "config.h"
#include "LuaState.h"
#include "lua_stack.h"

using namespace std;


class VersionTest : public testing::Test {

protected:

    LuaState *L;

    virtual void SetUp() {

	L = new LuaState();
    }

    virtual void TearDown() {

	delete L;
    }
};



TEST_F( VersionTest, config ) {

    L->get_module_attr(  "saotrace.raygen", "version" );

    int err = lua_pcall( *L, 0, 1, 0 );
    ASSERT_EQ( 0, err ) << lua_tostring( *L, -1 );

    cerr << lua_tostring( *L, -1 ) << endl;

    EXPECT_STREQ( VERSION, lua_tostring( *L, -1 ) );
}

